# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = ['RestorePointArgs', 'RestorePoint']

@pulumi.input_type
class RestorePointArgs:
    def __init__(__self__, *,
                 virtual_machine_restore_point_collection_id: pulumi.Input[str],
                 crash_consistency_mode_enabled: Optional[pulumi.Input[bool]] = None,
                 excluded_disks: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a RestorePoint resource.
        :param pulumi.Input[bool] crash_consistency_mode_enabled: Is Crash Consistent the Consistency Mode of the Virtual Machine Restore Point. Defaults to `false`. Changing this forces a new resource to be created.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] excluded_disks: A list of disks that will be excluded from the Virtual Machine Restore Point. Changing this forces a new resource to be created.
        :param pulumi.Input[str] name: Specifies the name of the Virtual Machine Restore Point. Changing this forces a new resource to be created.
        """
        pulumi.set(__self__, "virtual_machine_restore_point_collection_id", virtual_machine_restore_point_collection_id)
        if crash_consistency_mode_enabled is not None:
            pulumi.set(__self__, "crash_consistency_mode_enabled", crash_consistency_mode_enabled)
        if excluded_disks is not None:
            pulumi.set(__self__, "excluded_disks", excluded_disks)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="virtualMachineRestorePointCollectionId")
    def virtual_machine_restore_point_collection_id(self) -> pulumi.Input[str]:
        return pulumi.get(self, "virtual_machine_restore_point_collection_id")

    @virtual_machine_restore_point_collection_id.setter
    def virtual_machine_restore_point_collection_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "virtual_machine_restore_point_collection_id", value)

    @property
    @pulumi.getter(name="crashConsistencyModeEnabled")
    def crash_consistency_mode_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Is Crash Consistent the Consistency Mode of the Virtual Machine Restore Point. Defaults to `false`. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "crash_consistency_mode_enabled")

    @crash_consistency_mode_enabled.setter
    def crash_consistency_mode_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "crash_consistency_mode_enabled", value)

    @property
    @pulumi.getter(name="excludedDisks")
    def excluded_disks(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list of disks that will be excluded from the Virtual Machine Restore Point. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "excluded_disks")

    @excluded_disks.setter
    def excluded_disks(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "excluded_disks", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the name of the Virtual Machine Restore Point. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class _RestorePointState:
    def __init__(__self__, *,
                 crash_consistency_mode_enabled: Optional[pulumi.Input[bool]] = None,
                 excluded_disks: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 virtual_machine_restore_point_collection_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering RestorePoint resources.
        :param pulumi.Input[bool] crash_consistency_mode_enabled: Is Crash Consistent the Consistency Mode of the Virtual Machine Restore Point. Defaults to `false`. Changing this forces a new resource to be created.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] excluded_disks: A list of disks that will be excluded from the Virtual Machine Restore Point. Changing this forces a new resource to be created.
        :param pulumi.Input[str] name: Specifies the name of the Virtual Machine Restore Point. Changing this forces a new resource to be created.
        """
        if crash_consistency_mode_enabled is not None:
            pulumi.set(__self__, "crash_consistency_mode_enabled", crash_consistency_mode_enabled)
        if excluded_disks is not None:
            pulumi.set(__self__, "excluded_disks", excluded_disks)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if virtual_machine_restore_point_collection_id is not None:
            pulumi.set(__self__, "virtual_machine_restore_point_collection_id", virtual_machine_restore_point_collection_id)

    @property
    @pulumi.getter(name="crashConsistencyModeEnabled")
    def crash_consistency_mode_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Is Crash Consistent the Consistency Mode of the Virtual Machine Restore Point. Defaults to `false`. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "crash_consistency_mode_enabled")

    @crash_consistency_mode_enabled.setter
    def crash_consistency_mode_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "crash_consistency_mode_enabled", value)

    @property
    @pulumi.getter(name="excludedDisks")
    def excluded_disks(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list of disks that will be excluded from the Virtual Machine Restore Point. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "excluded_disks")

    @excluded_disks.setter
    def excluded_disks(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "excluded_disks", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the name of the Virtual Machine Restore Point. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="virtualMachineRestorePointCollectionId")
    def virtual_machine_restore_point_collection_id(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "virtual_machine_restore_point_collection_id")

    @virtual_machine_restore_point_collection_id.setter
    def virtual_machine_restore_point_collection_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "virtual_machine_restore_point_collection_id", value)


class RestorePoint(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 crash_consistency_mode_enabled: Optional[pulumi.Input[bool]] = None,
                 excluded_disks: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 virtual_machine_restore_point_collection_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manages a Virtual Machine Restore Point.

        ## Import

        Virtual Machine Restore Point can be imported using the `resource id`, e.g.

        ```sh
        $ pulumi import azure:compute/restorePoint:RestorePoint example /subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/mygroup1/providers/Microsoft.Compute/restorePointCollections/collection1/restorePoints/restorePoint1
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] crash_consistency_mode_enabled: Is Crash Consistent the Consistency Mode of the Virtual Machine Restore Point. Defaults to `false`. Changing this forces a new resource to be created.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] excluded_disks: A list of disks that will be excluded from the Virtual Machine Restore Point. Changing this forces a new resource to be created.
        :param pulumi.Input[str] name: Specifies the name of the Virtual Machine Restore Point. Changing this forces a new resource to be created.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RestorePointArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages a Virtual Machine Restore Point.

        ## Import

        Virtual Machine Restore Point can be imported using the `resource id`, e.g.

        ```sh
        $ pulumi import azure:compute/restorePoint:RestorePoint example /subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/mygroup1/providers/Microsoft.Compute/restorePointCollections/collection1/restorePoints/restorePoint1
        ```

        :param str resource_name: The name of the resource.
        :param RestorePointArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RestorePointArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 crash_consistency_mode_enabled: Optional[pulumi.Input[bool]] = None,
                 excluded_disks: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 virtual_machine_restore_point_collection_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RestorePointArgs.__new__(RestorePointArgs)

            __props__.__dict__["crash_consistency_mode_enabled"] = crash_consistency_mode_enabled
            __props__.__dict__["excluded_disks"] = excluded_disks
            __props__.__dict__["name"] = name
            if virtual_machine_restore_point_collection_id is None and not opts.urn:
                raise TypeError("Missing required property 'virtual_machine_restore_point_collection_id'")
            __props__.__dict__["virtual_machine_restore_point_collection_id"] = virtual_machine_restore_point_collection_id
        super(RestorePoint, __self__).__init__(
            'azure:compute/restorePoint:RestorePoint',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            crash_consistency_mode_enabled: Optional[pulumi.Input[bool]] = None,
            excluded_disks: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            name: Optional[pulumi.Input[str]] = None,
            virtual_machine_restore_point_collection_id: Optional[pulumi.Input[str]] = None) -> 'RestorePoint':
        """
        Get an existing RestorePoint resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] crash_consistency_mode_enabled: Is Crash Consistent the Consistency Mode of the Virtual Machine Restore Point. Defaults to `false`. Changing this forces a new resource to be created.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] excluded_disks: A list of disks that will be excluded from the Virtual Machine Restore Point. Changing this forces a new resource to be created.
        :param pulumi.Input[str] name: Specifies the name of the Virtual Machine Restore Point. Changing this forces a new resource to be created.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RestorePointState.__new__(_RestorePointState)

        __props__.__dict__["crash_consistency_mode_enabled"] = crash_consistency_mode_enabled
        __props__.__dict__["excluded_disks"] = excluded_disks
        __props__.__dict__["name"] = name
        __props__.__dict__["virtual_machine_restore_point_collection_id"] = virtual_machine_restore_point_collection_id
        return RestorePoint(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="crashConsistencyModeEnabled")
    def crash_consistency_mode_enabled(self) -> pulumi.Output[Optional[bool]]:
        """
        Is Crash Consistent the Consistency Mode of the Virtual Machine Restore Point. Defaults to `false`. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "crash_consistency_mode_enabled")

    @property
    @pulumi.getter(name="excludedDisks")
    def excluded_disks(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        A list of disks that will be excluded from the Virtual Machine Restore Point. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "excluded_disks")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Specifies the name of the Virtual Machine Restore Point. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="virtualMachineRestorePointCollectionId")
    def virtual_machine_restore_point_collection_id(self) -> pulumi.Output[str]:
        return pulumi.get(self, "virtual_machine_restore_point_collection_id")

